#!/usr/bin/python
# -*- coding: utf-8 -*-

import array

from ... import num
from ... import ftdi
from . import constant
from .common import common

READ_BYTES = 8


class ListData(object):

	#####################################################################
	def __init__(self, dest):
		self.__initializing()
		self.mUSBMCA = dest
		self.mSpectrum = None

	#####################################################################
	def __initializing(self):
		self.mUSBMCA = None
		self.mLastException = None

	#########################################################
	def __getUseDestination(self, dest):
		_dest = dest if dest is not None else self.mUSBMCA
		return _dest

	#########################################################
	def read(self, dest = None):

		result = False
		rxdata = None
		rxbyte0 = 0

		usbmca = self.__getUseDestination(dest)
		ret0th, rxbytes = self.__getPendingBytes(usbmca)

		if rxbytes > 0:
			ret1st, rxdata, rxbyte0 = usbmca.Read(rxbytes)
			result = usbmca.isSuccess(ret1st)
		else:
			result = ret0th

		return rxdata, rxbyte0


	#########################################################
	def __getPendingBytes(self, dest = None):
		
		result = False
		rxdata = None
		rxbytes = 0
		usbmca = self.__getUseDestination(dest)

		ret0th, dummy = usbmca.RequestOnly("LISR", 0)

		if ret0th == ftdi.constant.FT_OK:
			ret1st, rxdata, rxbyte = usbmca.Read(READ_BYTES)
			rxcmd, rxvalue = common.analyzeCommand(rxdata)

			if usbmca.isSuccess(ret1st) == True and rxbyte == READ_BYTES:
				rxblocks = rxvalue & 0x0000ffff
				rxbytes = rxblocks * constant.LIST_BLOCKBYTES
				result = True

		return result, rxbytes
