#!/usr/bin/python
# -*- coding: utf-8 -*-

import ctypes
from ctypes import *

###################################################################
def cbytearraytotext(value):

	text = ''
	nbytes = len(value)
	text0  = ctypes.string_at(value, nbytes)

	nlast = nbytes

	for i in range(nbytes):
		if text0[i] == 0:
			nlast = i
			break

	text = text0[0:nlast] if nlast > 0 else text
	return text


###################################################################
class FT_DEVICE_LIST_INFO_NODE(Structure):
	
	_fields_ = [
		("Flags", c_uint),
		("Type", c_uint),
		("ID", c_uint),
		("LocID", c_uint),
		("SerialNumber", c_byte * 16),
		("Description", c_byte * 64),
		("ftHandle", c_void_p)
	]

	###################################################################
	def gettext(self, name):
		text0 = getattr(self, name)
		text = cbytearraytotext(text0)
		return text

	###################################################################
	def getSerialNumber(self):
		return self.gettext("SerialNumber")

###################################################################
class FT_DEVICE_DETAIL_INFO_NODE(object):

	def __init__(self):
		self.mIndex = 0
		self.mFlags = 0
		self.mType = 0
		self.mID = 0
		self.mLocId = 0
		self.mSerialNumber = ''
		self.mDescription = ''
		self.mHandle = None

